/*-----------------------------------------------------------*/
/*                    Fetomn - The game                     */
/*                                                           */
/*                                                           */
/*                                                           */
/*-----------------------------------------------------------*/

#include <stdio.h>
#include <allegro.h>

#include "fetoman.h"
#include "juego.h"


#define FPS 50

BITMAP *buffer;
DATAFILE *dfuentes;


volatile int contador_frames;
volatile int contador_frames2;
int blits;
int fps;
int contador;

void cuenta_frames(void)
{
	contador_frames++;
}
END_OF_FUNCTION(cuenta_frames);


void intro(void)
{
	int i,j,r,g,b;
	DATAFILE *menu;	

	menu = load_datafile("../data/menu.dat");
	
	//efesto blur+fueg
	clear_to_color(buffer,makecol(255,255,255));
	blit(menu[1].dat,buffer,0,0,90,60,143,120);
	contador=0;
	while(contador<5 && !key[KEY_ESC])
	{
		if(contador>2)
		for(i=87;i<235;i++)
		{
			for(j=58;j<237;j++)
			{
			r=((
				//getr16(_getpixel16(buffer,i,j))+
				getr16(_getpixel16(buffer,i+1,j))+
				getr16(_getpixel16(buffer,i-1,j))+
				getr16(_getpixel16(buffer,i,j+1))+
				getr16(_getpixel16(buffer,i,j-1)))/4);
			if(r<254) r+=2;
			g=((
				//getg16(_getpixel16(buffer,i,j))+
				getg16(_getpixel16(buffer,i+1,j))+
				getg16(_getpixel16(buffer,i-1,j))+
				getg16(_getpixel16(buffer,i,j+1))+
				getg16(_getpixel16(buffer,i,j-1)))/4);
			if(g<254) g+=2;
			b=((
				//getb16(_getpixel16(buffer,i,j))+
				getb16(_getpixel16(buffer,i+1,j))+
				getb16(_getpixel16(buffer,i-1,j))+
				getb16(_getpixel16(buffer,i,j+1))+
				getb16(_getpixel16(buffer,i,j-1)))/4);
			if(b<254) b+=2;
			putpixel(buffer,i,j+1,makecol16(r,g,b));
			}
		}
		contador_frames2++;
		if(contador_frames>=FPS)
		{
			contador_frames=0; 
			contador_frames2=0;
			fps=blits;
			blits=0;
			contador++;
		}
		blits++;
		//blit(buffer,screen,0,0,0,0,320,240);
		stretch_blit(buffer,screen,0,0,320,240,0,0,640,480);
		while(contador_frames2>contador_frames);	
	}
	
	clear_to_color(buffer,makecol(255,255,255));
	blit(menu[0].dat,buffer,0,0,100,60,121,123);
	contador=0;
	while(key[KEY_ESC]);
	while(contador<5 && !key[KEY_ESC])
	{
		if(contador>2)
		for(i=90;i<230;i++)
		{
			for(j=58;j<237;j++)
			{
			r=((
				//getr16(_getpixel16(buffer,i,j))+
				getr16(_getpixel16(buffer,i+1,j))+
				getr16(_getpixel16(buffer,i-1,j))+
				getr16(_getpixel16(buffer,i,j+1))+
				getr16(_getpixel16(buffer,i,j-1)))/4);
			if(r<254) r+=2;
			g=((
				//getg16(_getpixel16(buffer,i,j))+
				getg16(_getpixel16(buffer,i+1,j))+
				getg16(_getpixel16(buffer,i-1,j))+
				getg16(_getpixel16(buffer,i,j+1))+
				getg16(_getpixel16(buffer,i,j-1)))/4);
			if(g<254) g+=2;
			b=((
				//getb16(_getpixel16(buffer,i,j))+
				getb16(_getpixel16(buffer,i+1,j))+
				getb16(_getpixel16(buffer,i-1,j))+
				getb16(_getpixel16(buffer,i,j+1))+
				getb16(_getpixel16(buffer,i,j-1)))/4);
			if(b<254) b+=2;
			putpixel(buffer,i,j+1,makecol16(r,g,b));
			}
		}
		
		contador_frames2++;
		if(contador_frames>=FPS)
		{
			contador_frames=0; 
			contador_frames2=0;
			fps=blits;
			blits=0;
			contador++;
		}
		blits++;
		//blit(buffer,screen,0,0,0,0,320,240);
		stretch_blit(buffer,screen,0,0,320,240,0,0,640,480);
		while(contador_frames2>contador_frames);
	}
}

void menu(void)
{
	int i;
	int nivel=0;
	int boton_menu[10];
	int menu_actual=1;
	int tecla=FALSE;
	int fman3d=0;
	int fman3dx=110;
	int fman3dy=45;
	int recargar=FALSE;
	
	DATAFILE *menu;	
	DATAFILE *dfetoman3d;	

	menu = load_datafile("../data/menu.dat");
	dfetoman3d = load_datafile("../data/fetoman3d.dat");

	for(i=0;i<10;i++) boton_menu[i]=0;
	while(key[KEY_ESC]);
	while(nivel>=0) 
	{	
		
		
		tecla=TRUE;
		fman3d=0;
		fman3dx=110;
		fman3dy=45;
		while(menu_actual>=1)
		{
			if(fman3d<59) fman3d++; else fman3d=0;
			clear_to_color(buffer,makecol16(255,255,255));
			blit(menu[2].dat,buffer,0,0,0,0,320,240);

			switch(menu_actual)
			{
			case 1:
			{
				fman3dx=((fman3dx-200)/1.1)+200;
				fman3dy=((fman3dy-50)/1.1)+50;

				draw_trans_sprite(buffer,dfetoman3d[fman3d].dat,fman3dx,fman3dy);
				
				if(key[KEY_UP] && tecla==FALSE) {boton_menu[menu_actual]--; tecla=TRUE;}
				if(key[KEY_DOWN] && tecla==FALSE) {boton_menu[menu_actual]++; tecla=TRUE;}
				if(boton_menu[menu_actual]>4) boton_menu[menu_actual]=0;
				if(boton_menu[menu_actual]<0) boton_menu[menu_actual]=4;
					
				set_palette(dfuentes[4].dat);
				textprintf_centre(buffer,dfuentes[0].dat,100,50,-1,"--Fetoman--");
				
				if(boton_menu[menu_actual]==0){
					set_palette(dfuentes[5].dat);
					if(key[KEY_ENTER] && tecla==FALSE){
						menu_actual=0;
						nivel=1;
						tecla=TRUE;
					}
				}
				else set_palette(dfuentes[6].dat);
				textprintf_centre(buffer,dfuentes[0].dat,100,70,-1,"Nuevo Juego");
				if(boton_menu[menu_actual]==1){
					set_palette(dfuentes[5].dat);
				}
				else set_palette(dfuentes[6].dat);
				textprintf_centre(buffer,dfuentes[0].dat,100,90,-1,"Opciones");
				if(boton_menu[menu_actual]==2){
					set_palette(dfuentes[5].dat);
				}
				else set_palette(dfuentes[6].dat);
				textprintf_centre(buffer,dfuentes[0].dat,100,110,-1,"Passwords");
				if(boton_menu[menu_actual]==3){
					set_palette(dfuentes[5].dat);
					if(key[KEY_ENTER] && tecla==FALSE){
						menu_actual=2;
						nivel=0;
						tecla=TRUE;
					}
					
				}
				else set_palette(dfuentes[6].dat);
				textprintf_centre(buffer,dfuentes[0].dat,100,130,-1,"Creditos");
				if(boton_menu[menu_actual]==4){
					set_palette(dfuentes[5].dat);
					if(key[KEY_ENTER] && tecla==FALSE){
						menu_actual=0;
						nivel=-1;
						tecla=TRUE;
					}
				}
				else set_palette(dfuentes[6].dat);
				textprintf_centre(buffer,dfuentes[0].dat,100,150,-1,"Salir");
				
				if(key[KEY_ESC] && tecla==FALSE){
					menu_actual=0;
					nivel=-1;
					tecla=TRUE;
				}
				break;
			}
			case 2:
			{
				fman3dx=((fman3dx-10)/1.1)+10;
				fman3dy=((fman3dy-10)/1.1)+10;

				draw_trans_sprite(buffer,dfetoman3d[fman3d].dat,fman3dx,fman3dy);
				set_palette(dfuentes[4].dat);
				textprintf(buffer,dfuentes[0].dat,120,20,  -1,"Oh! Jola, estos son los");
				textprintf(buffer,dfuentes[0].dat,120,30,  -1,"creditos:");
				set_palette(dfuentes[1].dat);
				//textprintf(buffer,dfuentes[0].dat,120,40,  -1,"");
				textprintf(buffer,dfuentes[0].dat,120,50,  -1,"Programacion: Durmieu");
				textprintf(buffer,dfuentes[0].dat,120,60,  -1,"Graficos: Durmieu, Ilu");
				textprintf(buffer,dfuentes[0].dat,120,70,  -1,"Sonido: Nadie aun...");
				//textprintf(buffer,dfuentes[0].dat,120,80,  -1,"");
				textprintf(buffer,dfuentes[0].dat,120,90,  -1,"Jou!");
				textprintf(buffer,dfuentes[0].dat,120,100, -1,"<- Mola el fetoman, eh?");
				textprintf(buffer,dfuentes[0].dat,120,110, -1,"Aqui tendremos que poner");
				textprintf(buffer,dfuentes[0].dat,120,120, -1,"una especie de homenaje");
				textprintf(buffer,dfuentes[0].dat,120,130, -1,"a nuestro amigo fetoman");
				textprintf(buffer,dfuentes[0].dat,120,140, -1,"(y a su ayudante).");
				//textprintf(buffer,dfuentes[0].dat,120,150, -1,"");
				textprintf_centre(buffer,dfuentes[0].dat,160,160, -1,"Bueno, da rabia no tener ni idea de");
				textprintf_centre(buffer,dfuentes[0].dat,160,170, -1,"que coo poner en los creditos...");
				textprintf_centre(buffer,dfuentes[0].dat,160,180, -1,"Se me olvidan el copyright (que mal):");
				set_palette(dfuentes[2].dat);
				textprintf_centre(buffer,dfuentes[0].dat,160,200, -1,"(c)Copyright by The Fetoman Team 2002");
				if(boton_menu[menu_actual]==0){
					set_palette(dfuentes[5].dat);
					if(key[KEY_ENTER] && tecla==FALSE){
						menu_actual=1;
						nivel=0;
						tecla=TRUE;
					}
				}
				textprintf_centre(buffer,dfuentes[0].dat,160,220,-1,"Salir");
				if(key[KEY_ESC] && tecla==FALSE){
					menu_actual=1;
					nivel=0;
					tecla=TRUE;
				}
			}
			}
			
			contador_frames2++;
			if(contador_frames>=FPS)
			{
				contador_frames=0; 
				contador_frames2=0;
				fps=blits;
				blits=0;
			}
			if(contador_frames2>contador_frames)
			{
				blits++;
			}
			//blit(buffer,screen,0,0,0,0,320,240);
			stretch_blit(buffer,screen,0,0,320,240,0,0,640,480);
			
			while(contador_frames2>contador_frames);
			
			if(!(key[KEY_UP] || key[KEY_DOWN] || key[KEY_LEFT] || key[KEY_RIGHT] || key[KEY_ESC] || key[KEY_ENTER])) tecla=FALSE;
			
			//blit(buffer,screen,0,0,0,0,320,240);
			stretch_blit(buffer,screen,0,0,320,240,0,0,640,480);
		}
		
		if(nivel>=1)
		{
			carga_graficos(nivel);
			posiciona_fman(nivel);
			recargar=FALSE;
			while(key[KEY_ESC]);
			while((!key[KEY_ESC] && nivel>=1) && recargar==FALSE) 
			{
				teclado(nivel);
				render(nivel);
				
				if(key[KEY_ENTER] && nivel_acabao) {nivel++; recargar=TRUE;}
				if(nivel>1) nivel=0;
				
				contador_frames2++;
				if(contador_frames>=FPS)
				{
					contador_frames=0; 
					contador_frames2=0;
					fps=blits;
					blits=0;
				}
				if(contador_frames2>contador_frames)
				{
				//blit(buffer,screen,0,0,0,0,320,240);
				stretch_blit(buffer,screen,0,0,320,240,0,0,640,480);
					blits++;
				}
				
				while(contador_frames2>contador_frames);
			}
			menu_actual=1;
			boton_menu[menu_actual]=0;
			nivel=0;
		}
		
	}
}

int main()
{	
	allegro_init();
	install_keyboard();
	install_timer();
	
	set_color_depth (16);
	if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0) < 0) {
		allegro_message ("Super error al poner el modo grafico:\n%s\n", allegro_error);
		return -1;
	}
	
	dfuentes = load_datafile("../data/fuentes.dat");
	set_palette(dfuentes[1].dat);
	
	LOCK_FUNCTION(cuenta_frames);
	//LOCK_FUNCTION(segundos);
	LOCK_VARIABLE(contador_frames);
	LOCK_VARIABLE(contador_frames2);	

	install_int (cuenta_frames, 1000/FPS);
	//install_int (segundos, 1000);	
	
	buffer = create_bitmap(320,240);
	
	text_mode(-1);
	
	intro();
	
	drawing_mode(DRAW_MODE_TRANS,0,0,0);
	set_multiply_blender(0,0,0,255);
	
	menu();
	
	
	unload_datafile(dfuentes);
	allegro_exit();
	return (0);
}

END_OF_MAIN();

